'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.reduce = reduce;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var initialState = exports.initialState = {
  logs: [],
  selectedLog: null,
  selectedSnapshotItem: null
};

function reduce(state, commit) {
  switch (commit.type) {
    case 'AddLog':
      return _extends({}, state, {
        logs: [].concat(_toConsumableArray(state.logs), [{
          action: commit.action,
          snapshot: commit.snapshot
        }]),
        selectedLog: typeof state.selectedLog !== 'number' ? state.logs.length : state.selectedLog,
        selectedSnapshotItem: typeof state.selectedLog !== 'number' ? commit.snapshot[0] || null : state.selectedSnapshotItem
      });
    case 'Clear':
      return initialState;
    case 'SelectLog':
      return commit.logIndex === state.selectedLog ? state : _extends({}, state, {
        selectedLog: commit.logIndex,
        selectedSnapshotItem: state.logs[commit.logIndex].snapshot[0] || null
      });
    case 'SelectSnapshotItem':
      return _extends({}, state, {
        selectedSnapshotItem: commit.snapshotItem
      });
    default:
      return state;
  }
}