'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxShip = require('redux-ship');

var Ship = _interopRequireWildcard(_reduxShip);

var _controller = require('./controller');

var Controller = _interopRequireWildcard(_controller);

var _view = require('./view.code');

var _view2 = _interopRequireDefault(_view);

var _viewSnapshot = require('./view.snapshot.item');

var _viewSnapshot2 = _interopRequireDefault(_viewSnapshot);

var _util = require('./util');

var Util = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Snapshot = function (_PureComponent) {
  _inherits(Snapshot, _PureComponent);

  function Snapshot() {
    _classCallCheck(this, Snapshot);

    return _possibleConstructorReturn(this, (Snapshot.__proto__ || Object.getPrototypeOf(Snapshot)).apply(this, arguments));
  }

  _createClass(Snapshot, [{
    key: 'renderAll',
    value: function renderAll(snapshots) {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        { className: 'tile' },
        snapshots.map(function (snapshot) {
          return _this2.renderSnapshot(snapshot);
        })
      );
    }
  }, {
    key: 'renderSnapshotItem',
    value: function renderSnapshotItem(snapshotItem) {
      switch (snapshotItem.type) {
        case 'All':
          return this.renderAll(snapshotItem.snapshots);
        default:
          return _react2.default.createElement(_viewSnapshot2.default, {
            className: Util.snapshotItemClassName(snapshotItem),
            dispatch: this.props.dispatch,
            snapshotItem: snapshotItem,
            title: snapshotItem.type
          });
      }
    }
  }, {
    key: 'renderSnapshot',
    value: function renderSnapshot(snapshot) {
      var _this3 = this;

      return _react2.default.createElement(
        'div',
        { className: 'tile is-vertical' },
        snapshot.map(function (snapshotItem) {
          return _this3.renderSnapshotItem(snapshotItem);
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'p',
          { className: 'title is-5' },
          'Snapshot'
        ),
        this.props.snapshot && _react2.default.createElement(
          'div',
          { style: { marginBottom: 20 } },
          _react2.default.createElement(_view2.default, { isExpanded: false, json: this.props.snapshot })
        ),
        _react2.default.createElement(
          'div',
          { className: 'tile is-ancestor' },
          this.props.snapshot && this.renderSnapshot(this.props.snapshot)
        )
      );
    }
  }]);

  return Snapshot;
}(_react.PureComponent);

exports.default = Snapshot;